# Notes

This is where I'm putting my notes on this project and where I'm hitting
challenges in setting up stuff.

Ideally I'll be able to setup stuff so that the micro controller can be
abstracted. This way each family of controllers can have their own directories.

At the very least I plan to support the cortext m0+, m3 and m4..maybe at some
point I'll also add support for the H7 series.

## Challanges

- [ ] linker stuff.
- [ ] toolchain file arguments.
- [ ] CMSIS understanding
- [ ] STM32 HAL support and understanding.
- [ ] Better directory layout.
- [ ] debugging across platforms/os.


## Basics

I need to walk before I run I suppose.

AKA I should try to eliminate the fancy shit and just get it to correctly
build an flashable binary that blinks an led correctly on my
development board.

- [X] Remove RTOS stuff
- [X] Remove CMSIS stuff
- [X] Remove Unity test framework stuff.
- [X] Remove HAL stuff.
- [X] Remove doxygen stuff from toolchain file.
- [X] Check through debuging flags in toolchain file.

## Questions

- [X] What is semi-hosting in stm32 context.
- [X] What are mthumb or thumb?
- [ ] 
